<?php if ( ! defined( 'ABSPATH' ) ) exit; 

	//ENCRYPTION FUNCTION
	function sanitize_kbd_data( $input ) {

		if(is_array($input)){
		
			$new_input = array();
	
			foreach ( $input as $key => $val ) {
				$new_input[ $key ] = (is_array($val)?sanitize_kbd_data($val):sanitize_text_field( $val ));
			}
			
		}else{
			$new_input = sanitize_text_field($input);
		}
		
		return $new_input;
	}
	function kbd_backup_aliases($key){
		global $kbd_backup_aliases, $kbd_db_prefix;
		
		$key = str_replace($kbd_db_prefix, '', $key);
		
		return (isset($kbd_backup_aliases[$key])?$kbd_backup_aliases[$key]:$key);
	}

	if(!function_exists('kbd_encrypt')){


		function kbd_encrypt($decrypted, $password, $salt=''){


		 // Build a 256-bit $key which is a SHA256 hash of $salt and $password.


		 $key = hash('SHA256', $salt . $password, true);


		 // Build $iv and $iv_base64.  We use a block size of 128 bits (AES compliant) and CBC mode.  (Note: ECB mode is inadequate as IV is not used.)


		 srand(); 


                 if(function_exists('mcrypt_create_iv'))
                 $iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC), MCRYPT_RAND);
                 else
                 $iv = '鶵�^)W�D';


		 if (strlen($iv_base64 = rtrim(base64_encode($iv), '=')) != 22) return false;


		 // Encrypt $decrypted and an MD5 of $decrypted using $key.  MD5 is fine to use here because it's just to verify successful decryption.


		 $encrypted = base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $decrypted . md5($decrypted), MCRYPT_MODE_CBC, $iv));


		 // We're done!


		 return $iv_base64 . $encrypted;


		 }


	}
	//FOR QUICK DEBUGGING


	if(!function_exists('pre')){
	function pre($data){
			if(isset($_GET['debug'])){
				pree($data);
			}
		}	 
	} 	
	if(!function_exists('pree')){
	function pree($data){
				echo '<pre>';
				print_r($data);
				echo '</pre>';	
		
		}	 
	} 

	
	function kbd_menu(){

	    global $kbd_pro, $kbd_data;

        $kbd_settings = get_option('kbd_settings', array());
        $menu_title = $kbd_data['Name'];
        $callback_function = 'kbd_settings';
        $slug = 'kbd_settings';


        if($kbd_pro && array_key_exists('switch_to_premium', $kbd_settings)){

            $callback_function = 'kbd_settings_pro_callback';
            $slug = 'kbd_settings_pro';
        }


        add_options_page($menu_title, $menu_title, 'activate_plugins', $slug, $callback_function);
        add_submenu_page( null, 'Download Backup Daily', 'Backup Now', 'activate_plugins', 'kbd_download', 'kbd_download' );


	}
	
	function kbd_download() { 
		if ( !current_user_can( 'administrator' ) )  {

			wp_die( __( 'You do not have sufficient permissions to access this page.','wpkbd' ) );
		}	
		kbd_force_download();
	}

	//if(isset($_GET['page']) && $_GET['page']=='kbd_download')
	//kbd_force_download();


	
	function kbd_settings() { 

		if ( !current_user_can( 'administrator' ) )  {

			wp_die( __( 'You do not have sufficient permissions to access this page.','wpkbd' ) );
 			
		}

		 

		global $wpdb, $kbd_data, $kbd_pro; 
		$blog_info = get_bloginfo('admin_email');

		$salt = date('YmddmY')+date('m');

		//DEFAULT BACKUP RECIPIENT EMAIL ADDRESS	
		$default_email = get_bloginfo('admin_email');
		
		$default_email = $default_email!=''?$default_email:'info@'.str_replace('www.','',$_SERVER['HTTP_HOST']); 

		$kbd_settings_file = dirname(__FILE__).'/settings.dat';		//SETTINGS PARAMS TO BE STORED IN .DAT FILE		$settings = array();

		$settings['recpient_email_address']=array();

		$settings['backup_required'] = 'cron_d';

		$settings['maintain_log'] = 1;

		$settings['cron_server'] = 'default';				$settings['notification'] = '';

		$settings['notification_class'] = '';

		


		$kbd_log_file = dirname(__FILE__).'/log.dat';

		$settings['log'] = file_exists($kbd_log_file)?file_get_contents($kbd_log_file):'';

		 		//ENSURING THE VALID EMAIL ADDRESS	
		if(isset($_POST['recpient_email_address']) && isValidEmail($_POST['recpient_email_address']))

		{  

				//PREVENTING CSRF		
		
		if(isset($_POST['kbd_key']) && $_SESSION['kbd_key']==$_POST['kbd_key']) 
		{			$data = array(

			'backup_required'=>$_POST['backup_required'],

			'recpient_email_address'=>($_POST['recpient_email_address']==$default_email?'KBD':$_POST['recpient_email_address']),

			'maintain_log'=>$_POST['maintain_log'],

			'cron_server'=>$_POST['cron_server']			

			);

			//ACTION URL FOR BACKUP & EMAIL ACTIVITY			
			$submitted_url = update_kbd_cron($data);

			//STORING SETTINGS IN .DAT FILE			
			$data = serialize($data);

			$handle = fopen($kbd_settings_file,'wb+');

			fwrite($handle, $data);

			fclose($handle);			$settings['notification'] = 'Settings saved.';
			copy($kbd_settings_file, WP_PLUGIN_DIR.'/kbd_settings.dat');
			$settings['notification_class'] = 'updated';
			
			//GETTING EXPECTED BACKUP EMAIL TIME FROM SERVER

			$remote_uri = 'http://www.androidbubbles.com/api/kbd.php?next_backup='.time().'&backup_time='.$_POST['backup_required'].'&domain_url='.base64_encode($submitted_url);

			$_SESSION['expected_backup']=@file_get_contents($remote_uri);

		}

		else

		{

			$settings['notification'] = 'Access Denied.';

			$settings['notification_class'] = 'error';

		}

		

		}

		elseif(isset($_POST['recpient_email_address']))

		{

			$settings['notification'] = 'Invalid Email Address.';

			$settings['notification_class'] = 'error';

		}

		//STORING ENCRYPTION KEY IN SESSION	
		$_SESSION['kbd_key'] = $settings['kbd_key'] = kbd_encrypt($_SERVER['HTTP_HOST'].date('m'), $_SERVER['HTTP_HOST'], $salt);

		//LOADING STORED SETTINGS FROM .DAT FILE		
		$settings = load_kbd_settings($settings);				
		//ENSURING THAT RECIPIENT IS ONLY ONE	
		if(isset($settings['recpient_email_address']) && is_array($settings['recpient_email_address']) && count($settings['recpient_email_address'])==0)		{			$settings['recpient_email_address'][] = $default_email;		}		

						$settings['notification'] = $settings['notification_class']!=''?'<div class="'.$settings['notification_class'].' settings-error" id="setting-error-settings_updated"> 

<p><strong>'.$settings['notification'].'</strong></p></div>':'';		

		

            $expected_backup = isset($_SESSION['expected_backup'])?$_SESSION['expected_backup']:'';				//EXPECTED BACKUP EMAIL GENERATION TIME	
			$settings['cron_d']['expected_backup'] = '';
			$settings['cron_w']['expected_backup'] = '';
			$settings['cron_m']['expected_backup'] = '';
			$settings['cron_y']['expected_backup'] = '';
			$settings[$settings['backup_required']]['expected_backup'] = ($expected_backup!=''?'<div class="alert alert-success">
      <strong>'.__('Well done!','wpkbd').'</strong> '.__('Your backup will be in your inbox on time.','wpkbd','wpkbd').'</div>
':'');						

		include('kbd_settings.php');			

	}
use WPMechanic\KBFNR\Common\Util\Util;


function register_kbd_styles() {

		global $kbd_url;

		if(isset($_GET['page']) && in_array($_GET['page'] , array('kbd_settings', 'kbd_settings_pro', 'kbd_backup_list_pro'))){

		}else{
			return;
		}


		wp_register_style( 'kbd-style', plugins_url('css/style.css?t='.time(), dirname(__FILE__)) );
		wp_enqueue_style( 'kbd-style' );
		wp_enqueue_script(
			'kbd-scripts',
			plugins_url('js/scripts.js', dirname(__FILE__)),
			array('jquery')
		);
		
		$kbd_obj = array(

						'kbd_ajax_nonce' => wp_create_nonce('kbd_ajax_nonce'),
						'kbd_restore_msg' => __('Are you sure, you want to replace existing files with this archive?', 'wpkbd'),
						'finalizing_msg' => __('Finalizing replacements in tables', 'wpkbd'),
						'flush_msg' => __('Flushing caches', 'wpkbd'),
						'done_msg' => __('Completed', 'wpkbd'),
						'cancel_confirm' => __('Are your sure? You want to cancel find and replace process.', 'wpkbd'),
						'cancel' => __('The find & replace has been cancelled and all temporary data has been cleaned up.', 'wpkbd'),
						'required' => __('At least one find field is required to proceed.', 'wpkbd'),
						'this_url' => admin_url( 'admin.php?page=kbd_settings' ),
						'ingtr_tab' => (isset($_GET['t'])?$_GET['t']:'0'),
						'initiate_migration_nonce' => Util::create_nonce( 'initiate-migration' ),
						'migrate_table_nonce' => Util::create_nonce( 'migrate-table' ),

					);

		wp_localize_script('kbd-scripts', 'kbd_obj', $kbd_obj);

		wp_localize_jquery_ui_datepicker();
	}
	
	if(!function_exists('init_sessions')){


		function init_sessions(){


			if (!session_id()){

				ob_start();
				@session_start();


			}


		}


	}

	if(!function_exists('load_kbd_settings')){

		function load_kbd_settings($settings=array()){

			$kbd_settings_file = dirname(__FILE__).'/settings.dat';

			if(!file_exists($kbd_settings_file) && file_exists(WP_PLUGIN_DIR.'/kbd_settings.dat')){
				copy(WP_PLUGIN_DIR.'/kbd_settings.dat', $kbd_settings_file);				
				//unlink(WP_PLUGIN_DIR.'/kbd_settings.dat');
			}
			
			if(file_exists($kbd_settings_file)){

				$data = file_get_contents($kbd_settings_file);

				if($data!=''){

					if(is_array(unserialize($data)))


					{

						$data = unserialize($data);

						

						$settings = array_merge($settings, $data);
						
						if($settings['recpient_email_address']=='KBD'){
						
						$settings['recpient_email_address'] = get_bloginfo('admin_email');
						}

					}

				}

				

			}	
			return $settings;

		}	

	}
	if(!function_exists('log_kbd')){

		function log_kbd($string){

			$kbd_log_file = dirname(__FILE__).'/log.dat';

			if($string!='')

			{				

				if(file_exists($kbd_log_file)){

					$string = $string.'<br>'.file_get_contents($kbd_log_file);					

				}

				

				$f = fopen($kbd_log_file, 'wb+');

				fwrite($f, $string);

				fclose($f);

				

			}

		}

	}
	if(!function_exists('kbd_start')){


		function kbd_start(){	

				

		}	


	}
	if(!function_exists('kbd_end')){

		function kbd_end(){	

			$kbd_log_file = dirname(__FILE__).'/log.dat';

			if(file_exists($kbd_log_file)){


				unlink($kbd_log_file);


			}
			
			$data = array();

			return update_kbd_cron($data);		
		}

		

	}	
	
	
	if(!function_exists('update_kbd_cron')){

		function update_kbd_cron($data){	


			$wpurl = get_bloginfo('wpurl');


			$return = $data['p'] = $wpurl.'/?kbd_cron_process=1';

			$data = http_build_query($data);

			if(isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST']!='localhost'){
				
							
				$args = array(
					'body' => $data,
					'timeout' => '5',
					'redirection' => '5',
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array(),
					'cookies' => array()
				);
				$url = 'http://www.androidbubbles.com/api/kbd.php';
				$response = wp_remote_post( $url, $args );
				
								
				if ( is_wp_error( $response ) ) {
				   $error_message = $response->get_error_message();
				   _e("Something went wrong: $error_message",'wpkbd');
				} else {
				   //$response['body'];
				}
				
				

			}


			return $return;

		}

	}
	if(!function_exists('isValidEmail')){

		function isValidEmail($email){

	    //return preg_match("/^[_a-z0-9-]+(\.[_a-z0-9+-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,})$/i", $email);
		return is_email($email);

		}	

	}
	
	if(!function_exists('formatSizeUnits'))
	{
		function formatSizeUnits($bytes)
		{
			if ($bytes >= 1073741824)
			{
				$bytes = number_format($bytes / 1073741824, 2) . ' GB';
			}
			elseif ($bytes >= 1048576)
			{
				$bytes = number_format($bytes / 1048576, 2) . ' MB';
			}
			elseif ($bytes >= 1024)
			{
				$bytes = number_format($bytes / 1024, 2) . ' KB';
			}
			elseif ($bytes > 1)
			{
				$bytes = $bytes . ' bytes';
			}
			elseif ($bytes == 1)
			{
				$bytes = $bytes . ' byte';
			}
			else
			{
				$bytes = '0 bytes';
			}
		
			return $bytes;
		}
	}
	
	if(!function_exists('requirements_check'))
	{

		function requirements_check()
		{
			 $return = array();
			 $return['writable_dir'] = dirname(__FILE__);
			 
			 if(!is_writeable($return['writable_dir']))
			 @chmod($return['writable_dir'], 0777);
			 
			 $return['mcrypt_create_iv'] = function_exists('mcrypt_create_iv');
			 $return['ZipArchive'] = class_exists('ZipArchive');			 
			 $return['is_writable'] = is_writable($return['writable_dir']);
			 $return['finfo'] = class_exists('finfo');			 
			 
			 return $return;
		}
	}	
	
	
	if ( ! function_exists("file_parts"))
	{
		function file_parts($url,$params="ext")
		{
		
			if($params=="ext")
			{
			$parts = explode(".",$url);
			return end($parts);
			}
			elseif($params=="name")
			{
			$parts = explode("/",$url);
			return end($parts);
			}
			else
			{
			$parts = explode("/",$url);
			$file_name_ext = explode(".",end($parts));
			$file_name = array_pop($file_name_ext);
			return implode(".",$file_name);
			}
		}
	}	

	if ( ! function_exists("kbd_plugin_links"))
	{
		function kbd_plugin_links($links) { 
			global $kbd_premium_link, $kbd_pro;
			
			$settings_link = '<a href="options-general.php?page=kbd_settings">'.__('Settings','wpkbd').'</a>';
			
			if($kbd_pro){
				array_unshift($links, $settings_link); 
			}else{
				 
				$kbd_premium_link = '<a href="'.$kbd_premium_link.'" title="'.__('Go Premium','wpkbd').'" target=_blank>'.__('Go Premium','wpkbd').'</a>'; 
				array_unshift($links, $settings_link, $kbd_premium_link); 
			
			}
			
			
			return $links; 
		}
	}
		
	add_action( 'wp_ajax_update_kbd_bkup_alias', 'update_kbd_bkup_alias' );
	
	function update_kbd_bkup_alias() {
		global $wpdb, $kbd_backup_aliases, $kbd_db_prefix; // this is how you get access to the database
	
		if(isset($_POST['key']) && $_POST['key']!='' && isset($_POST['val']) && $_POST['val']!=''){
			
			
			
			$key = str_replace($kbd_db_prefix, '', $_POST['key']);
			$val = $_POST['val'];
			
			$kbd_backup_aliases[$key] = $val;
			

			if ( 
				! isset( $_POST['kbd_nonce_action_field'] ) 
				|| ! wp_verify_nonce( $_POST['kbd_nonce_action_field'], 'kbd_nonce_action' ) 
			) {
			
			   print __('Sorry, your nonce did not verify.','wpkbd');
			   exit;
			
			} else {
			
			   // process form data
			   update_option('kbd_backup_aliases', sanitize_kbd_data($kbd_backup_aliases));
			}			
			
		}
	
		wp_die(); // this is required to terminate immediately and return a proper response
	}

	//new code for find and replace


	if ( !function_exists( 'kbd_update_data' ) ) {
		function kbd_update_data($options,$old_data,$new_data){
			global $wpdb;
			$results = array();
			$queries = array(
				'content' =>		array("UPDATE $wpdb->posts SET post_content = replace(post_content, %s, %s)",  __('Content Items (Posts, Pages, Custom Post Types, Revisions)','wpkbd') ),
				'excerpts' =>		array("UPDATE $wpdb->posts SET post_excerpt = replace(post_excerpt, %s, %s)", __('Excerpts','wpkbd') ),
				'attachments' =>	array("UPDATE $wpdb->posts SET guid = replace(guid, %s, %s) WHERE post_type = 'attachment'",  __('Attachments','wpkbd') ),
				'links' =>			array("UPDATE $wpdb->links SET link_url = replace(link_url, %s, %s)", __('Links','wpkbd') ),
				'custom' =>			array("UPDATE $wpdb->postmeta SET meta_value = replace(meta_value, %s, %s)",  __('Custom Fields','wpkbd') ),
				'guids' =>			array("UPDATE $wpdb->posts SET guid = replace(guid, %s, %s)",  __('GUIDs','wpkbd') )
			);
			foreach($options as $option){
				if( $option == 'custom' ){
					$n = 0;
					$row_count = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->postmeta" );
					$page_size = 10000;
					$pages = ceil( $row_count / $page_size );

					for( $page = 0; $page < $pages; $page++ ) {
						$current_row = 0;
						$start = $page * $page_size;
						$end = $start + $page_size;
						$pmquery = "SELECT * FROM $wpdb->postmeta WHERE meta_value <> ''";
						$items = $wpdb->get_results( $pmquery );
						foreach( $items as $item ){
							$value = $item->meta_value;
							if( trim($value) == '' )
								continue;

							$edited = kbd_unserialize_replace( $old_data, $new_data, $value );

							if( $edited != $value ){
								$fix = $wpdb->query("UPDATE $wpdb->postmeta SET meta_value = '".$edited."' WHERE meta_id = ".$item->meta_id );
								if( $fix )
									$n++;
							}
						}
					}
					$results[$option] = array($n, $queries[$option][1]);
				}
				else{
					$result = $wpdb->query( $wpdb->prepare( $queries[$option][0], $old_data, $new_data) );
					$results[$option] = array($result, $queries[$option][1]);
				}
			}
			return $results;
		}
	}

	if ( !function_exists( 'kbd_unserialize_replace' ) ) {
		function kbd_unserialize_replace( $from = '', $to = '', $data = '', $serialised = false ) {
			try {
				if ( false !== is_serialized( $data ) ) {
					$unserialized = unserialize( $data );
					$data = kbd_unserialize_replace( $from, $to, $unserialized, true );
				}
				elseif ( is_array( $data ) ) {
					$_tmp = array( );
					foreach ( $data as $key => $value ) {
						$_tmp[ $key ] = kbd_unserialize_replace( $from, $to, $value, false );
					}
					$data = $_tmp;
					unset( $_tmp );
				}
				else {
					if ( is_string( $data ) )
						$data = str_replace( $from, $to, $data );
				}
				if ( $serialised )
					return serialize( $data );
			} catch( Exception $error ) {
			}
			return $data;
		}
	}